function parse_url (url)
	r = { string.find(url, '^http://([^/:]*)(:?[0-9]*)(/.*)') } 
	g = {}
	if r[1] ~= nil then
		g['host'] = r[3]
		g['port'] = r[4]
		g['query'] = r[5]
		if g['port'] == '' then
			g['port'] = '80'
		end
		return g
	end
	return nil
end

function httpc_open(t) 
	s = libhttpd.connect(t['host'], t['port'])
	libhttpd.write(s, 'GET ' .. t['query'] .. ' HTTP/1.0\r\n');
	libhttpd.write(s, '\r\n');  -- end of http query
	c, content = libhttpd.read(s)
	while  (c ~= 0) do	
		c, token = libhttpd.read(s)
		content = content .. token
	end
	
	-- split between header and content
	re = { string.find(content, '(.*)\r\n\r\n(.*)') }
	r = {}
	r['header'] = re[3]
	r['content'] = re[4]
	return r
end
