function json_encode_string(s)
	s = string.gsub(s,'\\','\\\\')
	s = string.gsub(s,'"','\\\"')
	s = string.gsub(s,"'","\\\'")
	s = string.gsub(s,'\n','\\\n')
	s = string.gsub(s,'\t','\\\t')
	return s
end


function json_table(mtable, complete) 
	local first
	
	if mtable == nil then
		out('nil')
		return
	end

	if complete == 1 then
		out ('{')
	end

	first = nil

	for i in next, mtable do
		if first == nil then
			first = 1
		else
			out(',')
		end
		
		if type(mtable[i]) == 'table' then
			out('"' .. i .. '" : ')
			json_table(mtable[i], 1)
		else
			mtable[i] = tostring(mtable[i])
			out('"' .. i .. '" : "' .. json_encode_string(mtable[i]) .. '"')
		end

	end


	if complete == 1 then
		out ('}')
	end


end
