require ('json')
require ('web.auth')
require ('send')

syn_max_per_page = 25

function encodeString(s)
	s = string.gsub(s,'\\','\\\\')
	s = string.gsub(s,'"','\\"')
	s = string.gsub(s,"'","\\'")
	s = string.gsub(s,'\n','\\n')
	s = string.gsub(s,'\t','\\t')
	return s 
end

function syn_send_value ( voie) 
	local voie_num = tonumber(voie)
	-- voie_info = mem:info_chan(voie)
	local to_send = ''

	if syn_one ~= nil then
		to_send = ', '
	else 
		syn_one = 1
	end

	-- if voie_info ~= nil then
	valeur = mem:read_chan_string(voie)
	to_send = to_send .. "V_".. voie .. " : '".. encodeString(valeur) .. "'"
	if mem:get_flag(voie, 'inhib')  then
		to_send = to_send .. ', VI_'.. tostring(voie)..' : 1'
	end

	out(to_send)
	-- end

end

function syn_read_one (chan) 
	chan = tonumber(parameters.chan)
	local t = mem:read_chan(chan)
	if t == nil then
		out('{}')
	else 
		json_table(t, 1)
	end
end

function syn_index (items) 
	out('{')
	 syn_one = nil
	if parameters.items == nil or parameters.items == '' then
		out('}')
	else
		string.gsub(parameters.items,'([0-9]+)', syn_send_value)
		out('}')
	end
	syn_one = nil
end

--function syn_oneinfo (p) 
--	voie = tonumber(p.voie)
--	send_one_chan(voie)
--end

--function syn_multinfo(p) 
--	out('{')
--	syn_one = nil
--	string.gsub(parameters.voie,'([0-9]+)', function (i)
--		if syn_one == nil then
--			syn_one = 1
--		else
--			out(', ')
--		end
--		out('"V_' .. i ..'" : ')
--		send_one_chan(tonumber(i))
--	end)
--	out('}')
--end
--
function syn_max_pages () 
	local j = 0
	local k = 1
	local i = mem:info().last_chan
	while k <= i do
		if mem:info_chan(k) ~= nil then
			j = j+1
		end 
		k = k + 1
	end
	local nb_page = j / syn_max_per_page
	out('{ "nb_pages": "' .. nb_page .. '"}')
end

--function syn_allinfo(p)
--	page = 0
--	lastchan = 1
--
--	if p.page == nil then
--		page = 0
--	else
--		page = tonumber(p.page)
--	end
--
--	out('[')

--	first_item = nil

	--s = auth_session_list[global_cookie]
	--if s == nil or s.lastchan == nil then
	--	lastchan = s.lastchan
	--else
	--	lastchan = 1
	--end
--	while j < (page+1) * syn_max_per_page and i <= 1500 do
--		if mem:info_chan(i) ~= nil then
--			j = j+1
--			if j > page * syn_max_per_page then
--				if first_item == nil then
--					first_item = 1
--				else
--					out(', ')
--				end
--				send_one_chan(i)
--			end
--		end 
--		i = i+1
--	end
--	out(']')
--end

function syn_get_infos (items) 
	out('[')
	syn_one = nil
	if (parameters.items == nil or parameters.items == '') then
		out(']')
		return
	end
	string.gsub(parameters.items,'([0-9]+)', function (j)
		if syn_one == nil then
			syn_one = 1
		else
			out(', ')
		end

		j = tonumber(j)

		if mem:info_chan(j) ~= nil then
			send_one_chan(j)
		end
	end)

	out(']')
end

function check_index_or(chan, indexes)
	local is_index = false
	string.gsub(indexes, '.', function (i)
		is_index = is_index or mem:check_index(chan, i)
	end)
	return is_index
end

function syn_init()
	s = global_session

	if parameters.filter == nil or parameters.filter == '' then
		if s ~= nil and s.user ~= nil and s.user.diag == 1 then
			t = mem:chan_list(1)
		else
			t = mem:chan_list(0)
		end
		
	elseif parameters.filter ~= nil then
		if s ~= nil and s.user ~= nil and s.user.diag == 1 then
			t = mem:chan_filter(parameters.filter, 1)
		else
			t = mem:chan_filter(parameters.filter, 0)
		end

	end

	if parameters.index ~= nil then
		tt = {}
		for i in next, t do
			if check_index_or(t[i], parameters.index) then
				tt[i] = t[i]
			end
		end
		t = tt
	end
	
	out('[')
	for i in next, t do
		out( t[i] .. ',')
	end
	out(']')

end

