-- com = perax:open_com()
-- mem = perax:open_mem()

require('web.auth')

function write_chan(p)
	s = global_session

	if s == nil or s.user == nil then
		sendError(global_client, 403, "Unauthorized")
		return
	end


	if s.user and s.user.write == 1 then
		com:write_chan(tonumber(p.voie), p.type, tonumber(p.value))
	else
		out('["Pas les droits", "--"]')
		return 
	end

	chan = mem:read_chan(tonumber(p.voie))
	out('["'.. chan[p.type] ..'", "'.. s.user.name ..'"]')
end

function write_object() 
	local t = parameters.type
	local n = parameters.num
	local v = parameters.value
	
	local s = global_session

	if s == nil or s.user == nil then
		out('{"return" : 0, "message" : "Vous n\'etes pas identifie."}');
		return
	end

	if s.user.write ~= 1 then
		out('{"return" : 0, "message" : "Vous n\'avez pas les droits en ecriture."}');
		return
	end

	local tt = ''
	if t == 'ETOR' or t == 'STOR' then
		tt = 'bool'
	elseif t == 'CHO' or t == 'CHR' then
		tt = 'long'
	elseif t == 'CPT' then
		tt = 'float'
	elseif t == 'CE' then
		tt = 'short'
	else -- CR
		tt = 'float'
	end

	
	local ret 
	local nouvelle 
	if t == 'CE' or t == 'CR' then
	        ret = com:write_cons(n, tt, tonumber(v))
		perax.sleep(0.9)
		local tab 
		if t == 'CE' then
			tab = mem:read_cons(n, 0)
		else
			tab = mem:read_cons(n, 1)
		end
		--		print ('Consigne ' .. t .. ' ' .. tt .. ' ' .. tostring(n) .. ' ' .. tonumber(v) .. " retour " .. ret)
		nouvelle = tab['value']
	else
		ret = com:write_chan(n, tt, tonumber(v))
		perax.sleep(0.9)
		nouvelle = mem:read_chan_string(n)	
	end

		
	if ret ~= nil then
		message = t .. " " .. tostring(n) .. " nouvelle valeur : " .. nouvelle
		out('{"return" : 1, "message" :"' .. message ..'"}');
	else
		message = t .. " " .. tostring(n) .. " erreur a l'ecriture ."
		out('{"return" : 0, "message" : "'.. message ..'"}');
	end
end

