require('json')
auth_session_list = {}

function auth_cookie(p)
	-- activation of the cookie
	-- anonymous session working now
	local user = nil
	local send_cookie = false
	local num

	if p.user ~= nil and p.pass ~= nil then
	 	user = perax.auth(p.user, p.pass)
	end

	if not global_session then

 		num = tostring(math.random())
		auth_session_list[num]  = {}

		global_session = auth_session_list[num]
		global_session.start = perax.time()

		send_cookie = true
	end
	
	if user then
		global_session.user = user
	end

	if send_cookie then
		return 'luap4', num
	else 
		return nil
	end
end


function auth_get_list () 
	json_table(auth_session_list, 1)
end


function auth_index(p) 
	local s = auth_session_list[global_cookie]
	local write = 0
	local diag = 0
	if s and s.user then
		if s.user.write == 1 then
			write = 1
		end
		if s.user.diag == 1 then
			diag = 1
		end
		if s.user ~= nil then
			out('["1", "'.. s.user.name ..'", "' .. write ..'", "' .. diag ..'"]' )
		else
			out('["0"]')
		end
	else
		out('["0"]')
	end
end

function auth_quit(p)
	if global_session ~= nil then
		auth_session_list[global_cookie] = nil
		out ('"votre session a ete desactivee"')
	else
		out('"vous n\'etes pas connecte."')
	end
end
