require('json')

function cgidm_index() 
	local chan = tonumber(parameters.chan)
	local t = mem:info_chan(chan)

	if dm == nil then
		dm = perax:open_dm()
	end

	dmt = dm:info(chan)
	dm:read(chan)
	local d = mem:read_chan_string(chan)

	local val_num = 100

	if parameters.val_num ~= nil then
		val_num = tonumber(parameters.val_num)
	end

	r = {}
	if t.type == 'ETOR' or t.type == 'STOR' then
		r.a = 0;
		r.b = 0;
	else
		r.a = t.a
		r.b = t.b
	end

	r.unite = t.unite
	r.active = t.active
	r.name = t.name
	r.current = d
	r.type = t.type
	
	out ('{');
	json_table(r, 0);

	out (', "data" : [')
	
	local start = 1
	if dmt.valid_lines > val_num then
		start = dmt.valid_lines - val_num
	end
	for i = start,dmt.valid_lines do
		local d = dm:getnpure(mem, i)
		if d ~= nil then
			out ('[' .. tostring(d.date));
			out (','.. tostring(d.value)..' ],' );
		end
	end
	out (']}')
	
end
